/**
 * @Name metadata.sql
 * @Purpose Custom metadata
 * @Date 1 July 2014
 * @Author S.Deckers
 * @Description
 */ 

-- cleanup
delete from g3e_analysis where g3e_table = 'PLE_METADATASUPPORT';
-- EOF cleanup

/* --- 2do : Create trigger to check if fno/cno/ano combination exists (20140703 SDE) */
CREATE TABLE PLE_COMMONATTRIBUTES
(
  PLE_CONO				NUMBER( 9)	constraint	PLE_COMMONATTRIBUTES_CONO 		primary key,
  G3E_FNO           	NUMBER( 5)	NOT NULL,
  G3E_CNO  				NUMBER( 5)	NOT NULL,
  G3E_ANO  				NUMBER( 9)	NOT NULL,
  G3E_EDITDATE        	DATE 		NOT NULL,
  constraint t_uk unique ( G3E_FNO, G3E_CNO, G3E_ANO) 
);
                   
CREATE TABLE PLE_METADATASUPPORT
(
  PLE_MSNO				NUMBER( 9)			constraint  		M_N_PLE_METADATASUPPORT_MSNO 	primary key,
  G3E_TABLE           	VARCHAR2(30 BYTE)	NOT NULL CONSTRAINT M_U_PLE_METADATASUPPORT_TABLE 	unique,
  G3E_OPTIMIZEDTABLE  	VARCHAR2(30 BYTE)	NOT NULL CONSTRAINT M_U_PLE_METADATASUPPORT_OPTABL 	unique,
  G3E_EDITDATE        	DATE 				NOT NULL
);

insert into PLE_METADATASUPPORT	( PLE_MSNO, G3E_TABLE, 				G3E_OPTIMIZEDTABLE, 			G3E_EDITDATE )
					 	values	( 1,		'PLE_COMMONATTRIBUTES',	'PLE_COMMONATTRIBUTES_OPTABLE',	sysdate);

-- Extend regular GTech tables (20140701 SDE)
insert into G3E_ANALYSIS (	G3E_ADNO, 			G3E_USERNAME, 	G3E_TYPE, 	G3E_TABLE, 				G3E_OPTIMIZEDTABLE, 			G3E_TOOLTIP, 								G3E_EDITDATE)
 				select  	max(G3E_ADNO)+1 , 	'PLE Metadata',	'General',	'PLE_METADATASUPPORT',	'PLE_METADATASUPPORT_OPTABLE',	'Provides access to the PLE metadata.',    	sysdate from G3E_ANALYSIS;

/* --- Test data */     
insert into PLE_COMMONATTRIBUTES( PLE_CONO, G3E_FNO, 	G3E_CNO, 	G3E_ANO, 	G3E_EDITDATE )
						values	( 1,		22,			2202,		220206,		sysdate);
insert into PLE_COMMONATTRIBUTES( PLE_CONO, G3E_FNO, 	G3E_CNO, 	G3E_ANO, 	G3E_EDITDATE )
						values	( 2,		22,			2202,		220207,		sysdate);
insert into PLE_COMMONATTRIBUTES( PLE_CONO, G3E_FNO, 	G3E_CNO, 	G3E_ANO, 	G3E_EDITDATE )
						values	( 3,		23,			2302,		230206,		sysdate);
insert into PLE_COMMONATTRIBUTES( PLE_CONO, G3E_FNO, 	G3E_CNO, 	G3E_ANO, 	G3E_EDITDATE )
						values	( 4,		23,			2302,		230207,		sysdate);

COMMIT;